<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 68</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome Icons -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
</head>

<body class="hold-transition sidebar-mini">

    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Home</a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Devcamp 120</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user panel (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Hồ Bá TRường</a>
                    </div>
                </div>


                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Starter Pages
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="Voucher.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    Voucher list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="CMenu.html" class="nav-link active">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    CMenu list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="CDrink.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    CDrink list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="Country.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    Country list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="User.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    User list
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h2>DANH SÁCH MENU</h2>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Menu list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <div class="content">
                <div class="container-fluid">
                    <div class="row">
                        <button class="btn btn-primary" id="btn-create"><i class="fa-solid fa-plus"></i> &nbsp; Create
                            Menu</button>
                        <div class="col-12">
                            <table class="table table-bordered table-striped table-hover" id="menu-table">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Size</th>
                                        <th>Đường kính</th>
                                        <th>Sườn</th>
                                        <th>Salad</th>
                                        <th>Số lượng nước ngọt</th>
                                        <th>Đơn giá</th>
                                        <th>Action</th>
                                    </tr>
                            </table>
                            <!-- Vùng Modal -->
                            <!-- Create Order modal -->
                            <div>
                                <div id="create-menu-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Create menu
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Size</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-size"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Đường Kính</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-create-duongkinh"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Sườn</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-create-suon"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Salad</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-create-salad"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Số lượng nước ngọt</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-create-drink"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Đơn giá</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-create-price"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-create-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-create-menu">Create
                                                    menu</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Update Order modal -->
                            <div>
                                <div id="update-menu-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Update Trạng Thái menu
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Size</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-size"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Đường Kính</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-update-duongkinh"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Sườn</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-update-suon"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Salad</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-update-salad"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Số lượng nước ngọt</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-update-drink"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Đơn giá</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="number" id="input-update-price"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-update-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-update-menu">Update Trạng
                                                    Thái</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Delete confirm modal -->
                            <div>
                                <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">menu Delete Confirmation
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <label>Bạn có chắc chắn muốn xóa menu này không?</label>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-danger"
                                                    id="btn-confirm-delete-menu">Confirm</button>
                                                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <!-- Order Detail modal -->
                            <div>

                            </div>
                        </div>
                    </div>
                    <!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content -->
        </div>
        <!-- Main Footer -->
        <footer class="main-footer">
            <!-- To the right -->
            <div class="float-right d-none d-sm-inline">
                DANH SÁCH ĐƠN HÀNG
            </div>
            <!-- Default to the left -->
            <strong>Copyright &copy; 2023 Devcamp 120.</strong> All rights
            reserved.
        </footer>
    </div>
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <script>
        "use strict";
        $(document).ready(function () {
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gBASE_URL = "http://localhost:8080/menus";

            const gCOLUMN_ID = 0;
            const gCOLUMN_SIZE = 1;
            const gCOLUMN_DUONG_KINH = 2;
            const gCOLUMN_SUON = 3;
            const gCOLUMN_SALAD = 4;
            const gCOLUMN_SO_LUONG_DRINK = 5;
            const gCOLUMN_DON_GIA = 6;
            const gCOLUMN_ACTION = 7;

            const gCOLUMN = ["id", "size", "duongKinh", "suon", "salad", "soLuongNuocNgot", "donGia", "action"];

            var gMenu_code = {
                id: "",
            }
            // định nghĩa table  - chưa có data
            var gmenuTable = $("#menu-table").DataTable({
                // Khai báo các cột của datatable
                "columns": [
                    { "data": gCOLUMN[gCOLUMN_ID] },
                    { "data": gCOLUMN[gCOLUMN_SIZE] },
                    { "data": gCOLUMN[gCOLUMN_DUONG_KINH] },
                    { "data": gCOLUMN[gCOLUMN_SUON] },
                    { "data": gCOLUMN[gCOLUMN_SALAD] },
                    { "data": gCOLUMN[gCOLUMN_SO_LUONG_DRINK] },
                    { "data": gCOLUMN[gCOLUMN_DON_GIA] },
                    { "data": gCOLUMN[gCOLUMN_ACTION] }
                ],
                // Ghi đè nội dung của cột action, chuyển thành button chi tiết
                "columnDefs": [
                    {
                        "targets": gCOLUMN_ACTION,
                        "defaultContent": '<i class="fas fa-pen text-info edit-menu"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-menu"></i>'
                    }]
            });

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            $("#btn-create").on("click", function () {
                $("#create-menu-modal").modal("show");
            });
            $("#btn-create-menu").on("click", function () {
                onCreatemenu();
            });
            $("#menu-table").on("click", ".edit-menu", function () {
                onButtonChiTietClick(this); // this là button được ấn
            });
            // khi ấn nút sự kiện update trên modal
            $("#btn-update-menu").on("click", function () {
                onBtnUpdateClick();
            });
            // khi ấn sự kiện delete
            $("#menu-table").on("click", ".delete-menu", function () {
                onBtnDeleteConfirmOrderClick(this);
            });
            // gán sự kiện cho nút Delete  (trên modal)
            $("#btn-confirm-delete-menu").on("click", function () {
                onBtnDeletemenuClick();
            });
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            // Hàm sự kiện thêm menu
            function onCreatemenu() {
                // khai báo dữ liệu
                var vMenuObj = {
                    size: "",
                    duongKinh: -1,
                    suon: -1,
                    salad: -1,
                    soLuongNuocNgot: -1,
                    donGia: -1
                }
                // thu thập thông tin 
                getCreateData(vMenuObj);
                // validate
                if (kiemtraCreateData(vMenuObj)) {
                    // Tạo mới order
                    createmenu(vMenuObj);
                }
            }
            // hàm thu thập thông tin để create order
            function getCreateData(paramObj) {
                paramObj.size = $("#input-create-size").val();
                paramObj.duongKinh = $("#input-create-duongkinh").val();
                paramObj.suon = $("#input-create-suon").val();
                paramObj.salad = $("#input-create-salad").val();
                paramObj.soLuongNuocNgot = $("#input-create-drink").val();
                paramObj.donGia = $("#input-create-price").val();
            }
            function kiemtraCreateData(paramObj) {
                if (paramObj.size == "") {
                    alert("Bạn điền Size không hợp lệ")
                    return false;
                }
                if (paramObj.duongKinh == 0) {
                    alert("Bạn điền đường kính không hợp lệ")
                    return false;
                }
                if (paramObj.suon == 0) {
                    alert("Bạn điền sườn không hợp lệ")
                    return false;
                }
                if (paramObj.salad == 0) {
                    alert("Bạn điền salad không hợp lệ")
                    return false;
                }
                if (paramObj.soLuongNuocNgot == 0) {
                    alert("Bạn điền số lượng nước ngọt không hợp lệ")
                    return false;
                }
                if (paramObj.donGia == 0) {
                    alert("Bạn điền đơn giá không hợp lệ")
                    return false;
                }
                return true;
            }
            //Hàm tạo đơn mói
            function createmenu(paramObj) {
                $.ajax({
                    url: gBASE_URL,
                    type: 'POST',
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (paramObjmenu) {
                        //hiển thị dữ liệu lên web
                        console.log(paramObjmenu);
                        onPageLoading();
                        $("#create-menu-modal").modal("hide");
                        alert("Bạn tạo thành công menu");
                        $("#input-create-size").val("");
                        $("#input-create-duongkinh").val("");
                        $("#input-create-suon").val("");
                        $("#input-create-salad").val("");
                        $("#input-create-drink").val("");
                        $("#input-create-price").val("");
                    },
                    error: function (error) {
                        alert("Bạn tạo Đơn menu thất bại!");
                        $("#create-menu-modal").modal("hide");
                        $("#input-create-size").val("");
                        $("#input-create-duongkinh").val("");
                        $("#input-create-suon").val("");
                        $("#input-create-salad").val("");
                        $("#input-create-drink").val("");
                        $("#input-create-price").val("");
                        console.log(error.responseText)
                    }
                });
            }
            // infoFunction sẽ là function các nút cùng gọi
            function onButtonChiTietClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gmenuTable.row(vRowSelected);
                //Lấy data của dòng 
                var vmenuData = vDatatableRow.data();
                gMenu_code.id = vmenuData.id;
                // lấy api để load vào modal
                getmenubymenuID();
                $("#update-menu-modal").modal("show");
            }
            function getmenubymenuID() {
                $.ajax({
                    url: "http://localhost:8080/menus/" + gMenu_code.id,
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToModal(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm load data to modal update
            function loadDataToModal(paramResponseObject) {
                $("#input-update-size").val(paramResponseObject.size);
                $("#input-update-duongkinh").val(paramResponseObject.duongKinh);
                $("#input-update-suon").val(paramResponseObject.suon);
                $("#input-update-salad").val(paramResponseObject.salad);
                $("#input-update-drink").val(paramResponseObject.soLuongNuocNgot);
                $("#input-update-price").val(paramResponseObject.donGia);
            }
            function onPageLoading() {
                //Khai báo dữ liệu
                //validate
                // lấy data từ server
                getAllmenubyapi();
                // Xử lý front-end
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            function getAllmenubyapi() {
                $.ajax({
                    url: gBASE_URL,
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToTable(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // load data to table
            function loadDataToTable(paramResponseObject) {
                //Xóa toàn bộ dữ liệu đang có của bảng
                gmenuTable.clear();
                //Cập nhật data cho bảng 
                gmenuTable.rows.add(paramResponseObject);
                //Cập nhật lại giao diện hiển thị bảng
                gmenuTable.draw();
            }
            // khi bấm nút Update trên modal
            function onBtnUpdateClick() {
                console.log(gMenu_code.id);
                //khai báo dữ liệu
                var vObjectRequest = {
                    size: "",
                    duongKinh: -1,
                    suon: -1,
                    salad: -1,
                    soLuongNuocNgot: -1,
                    donGia: -1
                }
                // gán dữ liệu
                vObjectRequest.size = $("#input-update-size").val();
                vObjectRequest.duongKinh = $("#input-update-duongkinh").val();
                vObjectRequest.suon = $("#input-update-suon").val();
                vObjectRequest.salad = $("#input-update-salad").val();
                vObjectRequest.soLuongNuocNgot = $("#input-update-drink").val();
                vObjectRequest.donGia = $("#input-update-price").val();
                //validate
                var validate = kiemtraCreateData(vObjectRequest);
                if (validate) {
                    //cập nhật trạng thái
                    updateMenu(vObjectRequest);
                }
            }
            //update menu
            function updateMenu(paramObj) {
                $.ajax({
                    url: gBASE_URL + "/" + gMenu_code.id,
                    type: "PUT",
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        handleUpdatetSuccess(responseObject.id);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm xử lý sự kiện delete order modal click
            function onBtnDeletemenuClick() {
                //khai báo dữ liệu
                //validate
                //gọi api
                $.ajax({
                    url: gBASE_URL + "/" + gMenu_code.id,
                    type: "DELETE",
                    contentType: "application/json; charset=utf-8",
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleDeletemenuSuccess();
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
                //hiển thị thông tin
            }
            // hàm xử lý hiển thị front-end khi update Trạng thái thành công
            function handleUpdatetSuccess(paramObj) {
                onPageLoading();
                alert("Update menu Id = " + paramObj + " thành công!");
                $("#update-menu-modal").modal("hide");
            }
            // hàm xử lý hiển thị front-end khi sửa menu thành công
            function handleDeletemenuSuccess() {
                onPageLoading();
                alert("Xóa menu thành công!");
                $("#delete-confirm-modal").modal("hide");
            }
            function onBtnDeleteConfirmOrderClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gmenuTable.row(vRowSelected);
                //Lấy data của dòng 
                var vmenuData = vDatatableRow.data();
                gMenu_code.id = vmenuData.id;
                // lấy api để load vào modal
                $("#delete-confirm-modal").modal("show");
            }
        });
    </script>
</body>

</html>